version: '3'
services:

  ###> OPENAPI ###
  swagger-editor:
    image: swaggerapi/swagger-editor
    ports:
      - "19000:8080"
    networks:
      - ex-book-admin-api-python-flask-restx
  swagger-ui:
    image: swaggerapi/swagger-ui
    volumes:
      - ./public/v1:/swagger
    environment:
      SWAGGER_JSON: /swagger/openapi.json
    ports:
      - "19010:8080"
    networks:
      - ex-book-admin-api-python-flask-restx
  ###< OPENAPI  ###

  ###> EX-BOOK-ADMIN-API ###
  # https://github.com/bitnami/bitnami-docker-mongodb/blob/master/README.md
  ex-book-admin-api-python-flask-restx-db:
    image: "docker.io/bitnami/mongodb:4.4"
    ports:
      - "47018:27017"
    volumes:
      - 'ex-book-admin-api-python-flask-restx-db-data:/bitnami/mongodb'
    environment:
      - MONGODB_ROOT_PASSWORD=vEoZs9tEk3jLqS76
      - MONGODB_USERNAME=ex-book-admin-api-python-flask-restx
      - MONGODB_PASSWORD=2vQU45haQCnDS8sO
      - MONGODB_DATABASE=ex-book-admin-api-python-flask-restx
    networks:
      - ex-book-admin-api-python-flask-restx
  ex-book-admin-api-python-flask-restx:
    build:
      context: .
      dockerfile: single-stage.Dockerfile
    command: ["flask", "run", "--host", "0.0.0.0", "--port", "8080"]
    ports:
      - "8883:8080"
    volumes:
      - ./secrets/docker.env.yaml:/secrets/local.env.yaml
    depends_on:
      - ex-book-admin-api-python-flask-restx-db
    networks:
      - ex-book-admin-api-python-flask-restx
  ###< EX-BOOK-ADMIN-API ###

networks:
  ex-book-admin-api-python-flask-restx:
    driver: bridge

volumes:
  data-volume:
  ex-book-admin-api-python-flask-restx-db-data:
    driver: local
